#include <math.h>
#include "heuristica.h"

extern int nFilas, nColumnas;

coste heuristicaAciertos(estado e, estado emeta)
{
/*  int f, c, result;

  result = 0;

  for (f = 0; f < nFilas; f++)
    for (c = 0; c < nColumnas; c++)
      if (e.tablero[f][c] != emeta.tablero[f][c] && emeta.tablero[f][c]!=0)         
	result++; 
*/
  return 0; // result;
}


coste heuristicaDistancias(estado e)
{ //El pollo va hacia el lado del bloque opuesto a
  //la casilla de destino, teniendo en cuenta las distancia del bloque al 
  //destino.
  int f, c, result;
  int fb, cb;
  int fd, cd;
  int distBD, distPP;


  f = e.filPollo;
  c = e.colPollo;
  fb = e.filBloque;
  cb = e.colBloque;
  fd = e.filDestino;
  cd = e.colDestino;

  


   distBD = abs(fb-fd) + abs(cb-cd);

   if (abs(fb-fd) >= abs(cb-cd)) //destino mas lejos de bloque verticalmente
   {
      if (fd < fb) fb++;
      else         fb--;
   }
   else 
   {
      if (cd < cb) cb++;
      else         cb--;
   }

  distPP = abs(fb-f) + abs(cb-c);  
 
  result = distBD + distPP;
 
  return result;
}
coste heuristicaDistancias2(estado e)
{ //El pollo va hacia el lado del bloque opuesto a
  //la casilla de destino, teniendo en cuenta las distancias.
  int f, c, result;
  int fb, cb;
  int fd, cd;
  int distBD, distPP, distDPB ;


  f = e.filPollo;
  c = e.colPollo;
  fb = e.filBloque;
  cb = e.colBloque;
  fd = e.filDestino;
  cd = e.colDestino;

  


   distBD =  rint(1.3*(abs(fb-fd) + abs(cb-cd)));




   distDPB = (int) ceil(
            sqrt(
                (pow((f-fb),2) +  pow((c-cb),2))
               )
                      );
  
  if (abs(fb-fd) >= abs(cb-cd)) //destino mas lejos de bloque verticalmente
  {
     if (fd < fb) fb++;
     else         fb--;
  }
  else 
  {
     if (cd < cb) cb++;
     else         cb--;
  }



  distPP = 1*(abs(fb-f) + abs(cb-c));  
 
  result = distBD + distPP + distDPB;
 
  return result;
}


coste heuristicaObstaculos(estado e, estado emeta, ttablero tablero)
{
   int f, c, x, y, dt1=0, dt2=0, dt3=0, dt4=0, result;
   int fb, cb;
   int fd, cd;
  
  
  
   f = e.filPollo;
   c = e.colPollo;
   fb = e.filBloque;
   cb = e.colBloque;
   fd = e.filDestino;
   cd = e.colDestino;

   if (abs(fb-fd) >= abs(cb-cd)) //destino mas lejos verticalmente
   {
      if (fd < fb) fb++;
      else         fb--;
   }
   else 
   {
     if (cd < cb) cb++;
     else         cb--;
   }
  //fila 1
  if (f > fb) 
  {
    for (x=fb+1; x<=f; x++)
    {
       dt1++;
       dt2++;
       if (tablero[x][c]=='#')
           dt1=dt1+2;
       if (tablero[x][cb]=='#')
           dt2=dt2+2;

    } 
  }
  else
  {
    for (x=f+1; x<=fb; x++)
    {
       dt1++;
       dt2++;
       if (tablero[x][c]=='#')
           dt1=dt1+2;
       if (tablero[x][cb]=='#')
           dt2=dt2+2;

    } 
  }

  //columna 1
  if (c > cb) 
  {
    for (y=cb+1; y<=c; y++)
    {
       dt1++;
       dt2++;
       if (tablero[f][y]=='#')
           dt1=dt1+2;
       if (tablero[fb][y]=='#')
           dt2=dt2+2;

    } 
  }
  else
  {
    for (y=c+1; y<=cb; y++)
    {
       dt1++;
       dt2++;
       if (tablero[f][y]=='#')
           dt1=dt1+2;
       if (tablero[fb][y]=='#')
           dt2=dt2+2;

    } 
  }





   fb = e.filBloque;
   cb = e.colBloque;
  if (fd > fb) 
  {
    for (x=fb+1; x<=fd; x++)
    {
       dt3++;
       dt4++;
       if (tablero[x][cd]=='#')
           dt1=dt1+2;
       if (tablero[x][cb]=='#')
           dt2=dt2+2;

    } 
  }
  else
  {
    for (x=fd+1; x<=fb; x++)
    {
       dt3++;
       dt4++;
       if (tablero[x][cd]=='#')
           dt1=dt1+2;
       if (tablero[x][cb]=='#')
           dt2=dt2+2;

    } 
  }



  if (cd > cb) 
  {
    for (y=cb+1; y<=cd; y++)
    {
       dt3++;
       dt4++;
       if (tablero[fd][y]=='#')
           dt3=dt3+2;
       if (tablero[fb][y]=='#')
           dt4=dt4+2;

    } 
  }
  else
  {
    for (y=cd+1; y<=cb; y++)
    {
       dt3++;
       dt4++;
       if (tablero[fd][y]=='#')
           dt3=dt3+2;
       if (tablero[fb][y]=='#')
           dt4=dt4+2;

    } 
  }

  
  if (dt1 < dt2)
    result = dt1;
  else 
    result = dt2;

  if (dt3 < dt4)
    result=result + dt3;
  else
    result=result + dt4;
 

   return (result + abs(fb-fd) + abs(cb-cd));

}
coste heuristicaObsDis(estado e, ttablero tablero)
{
   return heuristicaDistancias(e) +   	heuristicaObstaculos(e,e,tablero);
}
