#include "puzzle.h"
#include "estado.h"
#include "operadores.h"

extern nFilas, nColumnas;


estado* moverNorte(estado einicial)
{
  estado *pefinal;
  int fP = einicial.filPollo;
  int cP = einicial.colPollo;
  int fB = einicial.filBloque;
  int cB = einicial.colBloque;

  pefinal = crearEstado();
  copiarEstado(einicial, pefinal);
  
  fP--;                           //se mueve el pollo
  if ((fB == fP) && (cB==cP))     //se mueve el bloque
     fB--;  

  pefinal->filPollo=fP;
  pefinal->filBloque=fB;
  return pefinal;
}

bool aplicableMoverNorte(estado e, ttablero tablero)
{
  int fP = e.filPollo;
  int cP = e.colPollo;
  int fB = e.filBloque;
  int cB = e.colBloque;
  int fD = e.filDestino;
  int cD = e.colDestino;
          
  
   //limite fisico
   if ((tablero[fP-1][cP]=='#') ||
     ((tablero[fB-1][cB]=='#')  && ((fP==fB+1) && (cP==cB))))
     return FALSE;

   //esquina
   if (( (tablero[fB-2][cB]=='#') && 
        ((tablero[fB-1][cB+1]=='#') ||
         (tablero[fB-1][cB-1]=='#')) 
       )
       && 
       ((fP-1==fB) && (cP==cB))
       &&
       (!((fB-1==fD) && (cB==cD)))
      )       
     return FALSE;


  return TRUE ;
}



estado* moverSur(estado einicial)
{
  estado *pefinal;
  int fP = einicial.filPollo;
  int cP = einicial.colPollo;
  int fB = einicial.filBloque;
  int cB = einicial.colBloque;

  pefinal = crearEstado();
  copiarEstado(einicial,pefinal);
  
  fP++;
  if ((fB == fP) && (cB==cP))
     fB++;  

  pefinal->filPollo=fP;
  pefinal->filBloque=fB;
  return pefinal;
}

bool aplicableMoverSur(estado e, ttablero tablero)
{
  int fP = e.filPollo;
  int cP = e.colPollo;
  int fB = e.filBloque;
  int cB = e.colBloque;
  int fD = e.filDestino;
  int cD = e.colDestino;

  if ((tablero[fP+1][cP]=='#') ||
     ((tablero[fB+1][cB]=='#')  && ((fP==fB-1) && (cP==cB)))) 
     return FALSE;

   //esquina
   if (( (tablero[fB+2][cB]=='#') && 
        ((tablero[fB+1][cB+1]=='#') ||
         (tablero[fB+1][cB-1]=='#')) 
       )
       && 
       ((fP+1==fB) && (cP==cB))
       &&
       (!((fB+1==fD) && (cB==cD)))
      )       
     return FALSE;




  return TRUE ;

}


estado* moverOeste(estado einicial)
{
  estado *pefinal;
  int fP = einicial.filPollo;
  int cP = einicial.colPollo;
  int fB = einicial.filBloque;
  int cB = einicial.colBloque;

  pefinal = crearEstado();
  copiarEstado(einicial,pefinal);
  
  cP--;
  if ((cB == cP) && (fB==fP))
     cB--;  
  
  pefinal->colPollo=cP;
  pefinal->colBloque=cB;
  return pefinal;
}

bool aplicableMoverOeste(estado e, ttablero tablero)
{
  int fP = e.filPollo;
  int cP = e.colPollo;
  int fB = e.filBloque;
  int cB = e.colBloque;
  int fD = e.filDestino;
  int cD = e.colDestino;

 
  if ((tablero[fP][cP-1]=='#') ||
     ((tablero[fB][cB-1]=='#')  && ((fP==fB) && (cP-1==cB)))) 
     return FALSE;

     //esquina
   if (( (tablero[fB][cB-2]=='#') && 
        ((tablero[fB+1][cB-1]=='#') ||
         (tablero[fB-1][cB-1]=='#')) 
       )
       && 
       ((fP==fB) && (cP-1==cB))
       &&
       (!((fB==fD) && (cB-1==cD)))
      )       
     return FALSE;

return TRUE ;
}


estado* moverEste(estado einicial)
{
  estado *pefinal;
  int fP = einicial.filPollo;
  int cP = einicial.colPollo;
  int fB = einicial.filBloque;
  int cB = einicial.colBloque;

  pefinal = crearEstado();
  copiarEstado(einicial,pefinal);
  
  cP++;
  if ((cB == cP) && (fB == fP))
     cB++;

  pefinal->colPollo=cP;
  pefinal->colBloque=cB;
  return pefinal;
}

bool aplicableMoverEste(estado e, ttablero tablero)
{
  int fP = e.filPollo;
  int cP = e.colPollo;
  int fB = e.filBloque;
  int cB = e.colBloque;
  int fD = e.filDestino;
  int cD = e.colDestino;

  if ((tablero[fP][cP+1]=='#') ||
     ((tablero[fB][cB+1]=='#')  && ((fP==fB) && (cP+1==cB))))  
     return FALSE;

     //esquina
  if (( (tablero[fB][cB+2]=='#') && 
       ((tablero[fB+1][cB+1]=='#') ||
        (tablero[fB-1][cB+1]=='#')) 
      )
      && 
      ((fP==fB) && (cP+1==cB))
      &&
      (!((fB==fD) && (cB+1==cD)))
     )       


   return TRUE;
}
