#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/times.h>
#include "nodos.h" 
#include "estado.h"
#include "operadores.h"
#include "busqueda.h"
#include "puzzle.h"

int nFilas, nColumnas;
ttablero tablero;

void verSolucion(estado *e, ttablero tablero)
{
   
   char c;
   FILE *fd;
   //leer fichero solucion

   fd = fopen("solucion","r");
   while(!feof(fd))
   {

      fscanf(fd,"%c\n",&c);
    
      printf("Siguiente movimiento %c, pulse una tecla...\n", c);
      getchar();
      switch (c) 
      {
      case 'N': e = moverNorte(*e);break;
      case 'S': e = moverSur(*e);break;
      case 'E': e = moverEste(*e);break;
      case 'O': e = moverOeste(*e);break;
      }
      verEstado(*e,tablero,12,12);
   }
   fclose(fd);
}



void inicializarTablero(ttablero tablero)
{
   int f, c;

   for (f=0; f < 15; f++)
      for (c=0; c < 15; c++)
         tablero[f][c]=' ';

}


void tratarArgumentos(int argc, char** argv, int* pnumAlg, int* pnumHeur)
{
  if (argc < 3)
    *pnumHeur = 0;
  else {
        *pnumAlg  = atoi(argv[1]);
        *pnumHeur = atoi(argv[2]);
       }  

}

void leerEstadosIF(estado** peinicial, ttablero tablero)
{
  int f,c,nf,nc;
  estado* p;
  FILE* fich;
  char car, salto;
  printf("Leyendo estado inicial\n");  
  fich = fopen("inicial","r");
  fscanf(fich,"%dx%d%c",&nf,&nc, &salto);
  nFilas    = nf;
  nColumnas = nc;
 
  *peinicial = crearEstado();  
  p = *peinicial;
  for (f=0; f < nf; f++)
  {  
    for (c=0; c < nc; c++)    
    {
      fscanf(fich,"%c",&car);
      if (car=='#') tablero[f][c]='#'; else
      if (car==' ') tablero[f][c]=' '; else
      if (car=='@') {p->filPollo=f; p->colPollo=c;}
else
      if (car=='0') {p->filBloque=f; p->colBloque=c;} else
      if (car=='.') {p->filDestino=f; p->colDestino=c;}
    } 
   
    fscanf(fich,"%c", &salto);
 
  }
  fclose(fich);
  *peinicial=p;
  printf("Leido estado inicial\n");
}


void escribirPaso(movimiento m, FILE *fich)
{
  int direccion;
  
  switch (m)
  {
    case NORTE:
      direccion = 'N';      
      break;
    case SUR:
      direccion = 'S';      
      break;
    case ESTE:
      direccion = 'E';      
      break;
    case OESTE:
      direccion = 'O';      
      break;
    default:
      printf("Movimiento no valido\n");
      direccion = '?';
      break;
  }  
    
  fprintf(fich,"%c\n",direccion);      
}



/*int calcular(estado e)
{
  int f,c,ff,cc;
  int valor=0;
  
  for (f=0; f < nFilas; f++)
    for (c=0; c < nColumnas; c++)
      for (ff=f; ff < nFilas; ff++)
        for (cc = (f==ff) ? c+1 : 0; cc < nColumnas; cc++)
           if (e.tablero[f][c] > e.tablero[ff][cc])
             valor++;
             
  if ((e.filaEspacioBlanco + e.colEspacioBlanco) % 2)             
    valor++;
  
  return valor;
}*/



/*bool problemaResoluble(estado e1, estado e2)
{
  int valorE1, valorE2;
  
  e1.tablero[e1.filaEspacioBlanco][e1.colEspacioBlanco] = nFilas*nColumnas;
  valorE1 = calcular(e1);  
  e1.tablero[e1.filaEspacioBlanco][e1.colEspacioBlanco] = VALOR_ESPACIO_BLANCO;
   
  e2.tablero[e2.filaEspacioBlanco][e2.colEspacioBlanco] = nFilas*nColumnas;
  valorE2 = calcular(e2);
  e2.tablero[e2.filaEspacioBlanco][e2.colEspacioBlanco] = VALOR_ESPACIO_BLANCO;
  
  return !((valorE1+valorE2) % 2);
}*/


/********************************************************************/
int main(int argc, char** argv)
{
  estado *peInicial,*peFinal;
  int nAlg, nHeur;

  inicializarTablero(tablero); 

  tratarArgumentos(argc,argv,&nAlg, &nHeur);
  leerEstadosIF(&peInicial,tablero);
  peFinal=crearEstado();
  copiarEstado(*peInicial, peFinal);
  
 
  printf("Main: Mostrando estado inicial %i\n", peInicial->filPollo);
  verEstado(*peInicial, tablero, nFilas, nColumnas);
  printf("Main: Mostrado estado inicial, comienza el algoritmo\n");

  if (TRUE) //(problemaResoluble(peInicial,*peFinal))
  {
    int i, nodosTotales;
    resultadoBusqueda res;
    FILE *fmovs,*fdatosGenerales;
    struct  tms tms;
    char resp;     
        
    printf("Main: Comienza la busqueda con alg: %i y heur: %i\n", nAlg, nHeur);	

    res = busqueda(peInicial,*peFinal, nAlg, nHeur, tablero);      
    
        
    fmovs = fopen("solucion","w");
    for (i=0; i < res.numMovs; i++)
      escribirPaso(res.movs[i],fmovs);
    fclose(fmovs);
    printf("Solucion escrita...\n");


    nodosTotales = res.nodosGenerados + res.nodosRepetidos;
    fdatosGenerales = fopen("generales","w");
    fprintf(fdatosGenerales,"Nodos totales: %d\nNodos generados: %d\nNodos repetidos: %d\nProfundidad: %d\nMovimientos: %d\n",
            nodosTotales, 
            res.nodosGenerados,
            res.nodosRepetidos, 
            res.maxProfundidad, 
            res.numMovs);
    
    times(&tms); 
    fprintf(fdatosGenerales,"%.6f seg\n",tms.tms_utime / (float)CLK_TCK);
    
    fclose(fdatosGenerales);
    
    printf("Datos generales escritos\n");
    system("cat generales");
    printf("Quieres ver la solucion?\n");
    resp=getchar();
    if (resp=='s') verSolucion(peInicial,tablero);

    close(1);

    return 0;
  }
  else  
  {
    close(1); 
    return 1;
  }  
}



